<!DOCTYPE html>
<html lang="en">
  <head>
    <title>Structures  Reference</title>
    <link rel="stylesheet" type="text/css" href="css/jazzy.css" />
    <link rel="stylesheet" type="text/css" href="css/highlight.css" />
    <meta charset='utf-8'>
    <script src="js/jquery.min.js" defer></script>
    <script src="js/jazzy.js" defer></script>
    
  </head>
  <body>
    <a name="//apple_ref/swift/Section/Structures" class="dashAnchor"></a>
    <a title="Structures  Reference"></a>
    <header>
      <div class="content-wrapper">
        <p><a href="index.html"> Docs</a> (96% documented)</p>
      </div>
    </header>
    <div class="content-wrapper">
      <p id="breadcrumbs">
        <a href="index.html"> Reference</a>
        <img id="carat" src="img/carat.png" />
        Structures  Reference
      </p>
    </div>
    <div class="content-wrapper">
      <nav class="sidebar">
        <ul class="nav-groups">
          <li class="nav-group-name">
            <a href="Protocols.html">Protocols</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Protocols/Place.html">Place</a>
              </li>
              <li class="nav-group-task">
                <a href="Protocols.html#/s:8PetriNet10TransitionP">Transition</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="Structs.html">Structures</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="Structs/Marking.html">Marking</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/PetriNet.html">PetriNet</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/PetriNet/ArcDescription.html">– ArcDescription</a>
              </li>
              <li class="nav-group-task">
                <a href="Structs/TotalMap.html">TotalMap</a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <article class="main-content">
        <section>
          <section class="section">
            <h1>Structures</h1>
            <p>The following structures are available globally.</p>

          </section>
          <section class="section task-group-section">
            <div class="task-group">
              <ul>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:8PetriNet7MarkingV"></a>
                    <a name="//apple_ref/swift/Struct/Marking" class="dashAnchor"></a>
                    <a class="token" href="#/s:8PetriNet7MarkingV">Marking</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>A marking of a Petri net.</p>

<p>A marking is a mapping that associates the places of a Petri net to the tokens they contain.</p>

<p>An algebra is defined over markings if the type used to represent the tokens associated with
each place (i.e. <code>PlaceType</code>) allows it. More specifically, markings are comparable if tokens
are too, and even conform to <code>AdditiveArithmetic</code> if tokens do to.</p>

<p>The following example illustrates how to perform arithmetic operations of markings:</p>
<pre class="highlight swift"><code><span class="k">let</span> <span class="nv">m0</span><span class="p">:</span> <span class="kt">Marking</span><span class="o">&lt;</span><span class="kt">P</span><span class="o">&gt;</span> <span class="o">=</span> <span class="p">[</span><span class="o">.</span><span class="nv">p0</span><span class="p">:</span> <span class="mi">1</span><span class="p">,</span> <span class="o">.</span><span class="nv">p1</span><span class="p">:</span> <span class="mi">2</span><span class="p">]</span>
<span class="k">let</span> <span class="nv">m1</span><span class="p">:</span> <span class="kt">Marking</span><span class="o">&lt;</span><span class="kt">P</span><span class="o">&gt;</span> <span class="o">=</span> <span class="p">[</span><span class="o">.</span><span class="nv">p0</span><span class="p">:</span> <span class="mi">0</span><span class="p">,</span> <span class="o">.</span><span class="nv">p1</span><span class="p">:</span> <span class="mi">1</span><span class="p">]</span>
<span class="nf">print</span><span class="p">(</span><span class="n">m0</span> <span class="o">+</span> <span class="n">m1</span><span class="p">)</span>
<span class="c1">// Prints "[.p0: 1, .p1: 3]"</span>
</code></pre>

                        <a href="Structs/Marking.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">public</span> <span class="kd">struct</span> <span class="kt">Marking</span><span class="o">&lt;</span><span class="kt">PlaceType</span><span class="o">&gt;</span> <span class="k">where</span> <span class="kt">PlaceType</span> <span class="p">:</span> <span class="kt"><a href="Protocols/Place.html">Place</a></span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
              </ul>
            </div>
            <div class="task-group">
              <ul>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:8PetriNetAAV"></a>
                    <a name="//apple_ref/swift/Struct/PetriNet" class="dashAnchor"></a>
                    <a class="token" href="#/s:8PetriNetAAV">PetriNet</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>A Petri net.</p>

<p><code>PetriNet</code> is a generic type, accepting two types representing the set of places and the set
of transitions that structurally compose the model. Both should conform to <code>CaseIterable</code>,
which guarantees that the set of places (resp. transitions) is bounded, and known statically.
The following example illustrates how to declare the places and transition of a simple Petri
net representing an on/off switch:</p>
<pre class="highlight swift"><code><span class="kd">enum</span> <span class="kt">P</span><span class="p">:</span> <span class="kt">Place</span> <span class="p">{</span>
  <span class="kd">typealias</span> <span class="kt">Content</span> <span class="o">=</span> <span class="kt">Int</span>
  <span class="k">case</span> <span class="n">on</span><span class="p">,</span> <span class="n">off</span>
<span class="p">}</span>

<span class="kd">enum</span> <span class="kt">T</span><span class="p">:</span> <span class="kt">Transition</span> <span class="p">{</span>
  <span class="k">case</span> <span class="n">switchOn</span><span class="p">,</span> <span class="n">switchOff</span>
<span class="p">}</span>
</code></pre>

<p>Petri net instances are created by providing the list of the preconditions and postconditions
that compose them. These should be provided in the form of arc descriptions (i.e. instances of
<code>ArcDescription</code>) and fed directly to the Petri net&rsquo;s initializer. The following example shows
how to create an instance of the on/off switch:</p>
<pre class="highlight swift"><code><span class="k">let</span> <span class="nv">model</span> <span class="o">=</span> <span class="kt">PetriNet</span><span class="o">&lt;</span><span class="kt">P</span><span class="p">,</span> <span class="kt">T</span><span class="o">&gt;</span><span class="p">(</span>
  <span class="o">.</span><span class="nf">pre</span><span class="p">(</span><span class="nv">from</span><span class="p">:</span> <span class="o">.</span><span class="n">on</span><span class="p">,</span> <span class="nv">to</span><span class="p">:</span> <span class="o">.</span><span class="n">switchOff</span><span class="p">),</span>
  <span class="o">.</span><span class="nf">post</span><span class="p">(</span><span class="nv">from</span><span class="p">:</span> <span class="o">.</span><span class="n">switchOff</span><span class="p">,</span> <span class="nv">to</span><span class="p">:</span> <span class="o">.</span><span class="n">off</span><span class="p">),</span>
  <span class="o">.</span><span class="nf">pre</span><span class="p">(</span><span class="nv">from</span><span class="p">:</span> <span class="o">.</span><span class="n">off</span><span class="p">,</span> <span class="nv">to</span><span class="p">:</span> <span class="o">.</span><span class="n">switchOn</span><span class="p">),</span>
  <span class="o">.</span><span class="nf">post</span><span class="p">(</span><span class="nv">from</span><span class="p">:</span> <span class="o">.</span><span class="n">switchOn</span><span class="p">,</span> <span class="nv">to</span><span class="p">:</span> <span class="o">.</span><span class="n">on</span><span class="p">),</span>
<span class="p">)</span>
</code></pre>

<p>Petri net instances only represent the structual part of the corresponding model, meaning that
markings should be stored externally. They can however be used to compute the marking resulting
from the firing of a particular transition, using the method <code>fire(transition:from:)</code>. The
following example illustrates this method&rsquo;s usage:</p>
<pre class="highlight swift"><code><span class="k">if</span> <span class="k">let</span> <span class="nv">marking</span> <span class="o">=</span> <span class="n">model</span><span class="o">.</span><span class="nf">fire</span><span class="p">(</span><span class="o">.</span><span class="n">switchOn</span><span class="p">,</span> <span class="nv">from</span><span class="p">:</span> <span class="p">[</span><span class="o">.</span><span class="nv">on</span><span class="p">:</span> <span class="mi">0</span><span class="p">,</span> <span class="o">.</span><span class="nv">off</span><span class="p">:</span> <span class="mi">1</span><span class="p">])</span> <span class="p">{</span>
  <span class="nf">print</span><span class="p">(</span><span class="n">marking</span><span class="p">)</span>
<span class="p">}</span>
<span class="c1">// Prints "[.on: 1, .off: 0]"</span>
</code></pre>

                        <a href="Structs/PetriNet.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">public</span> <span class="kd">struct</span> <span class="kt">PetriNet</span><span class="o">&lt;</span><span class="kt">PlaceType</span><span class="p">,</span> <span class="kt">TransitionType</span><span class="o">&gt;</span>
  <span class="k">where</span> <span class="kt">PlaceType</span><span class="p">:</span> <span class="kt"><a href="Protocols/Place.html">Place</a></span><span class="p">,</span> <span class="kt">PlaceType</span><span class="o">.</span><span class="kt">Content</span> <span class="o">==</span> <span class="kt">Int</span><span class="p">,</span> <span class="kt">TransitionType</span><span class="p">:</span> <span class="kt"><a href="Protocols.html#/s:8PetriNet10TransitionP">Transition</a></span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
              </ul>
            </div>
            <div class="task-group">
              <ul>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:8PetriNet8TotalMapV"></a>
                    <a name="//apple_ref/swift/Struct/TotalMap" class="dashAnchor"></a>
                    <a class="token" href="#/s:8PetriNet8TotalMapV">TotalMap</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>A total map.</p>

<p>A total map is analoguous to a dictionary for which all keys are guaranteed to be assigned to
a value. In more formal terms, it corresponds to a total function. You may prefer a total map
to a function for faster lookup, when values can be memoized.</p>

                        <a href="Structs/TotalMap.html" class="slightly-smaller">See more</a>
                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight swift"><code><span class="kd">public</span> <span class="kd">struct</span> <span class="kt">TotalMap</span><span class="o">&lt;</span><span class="kt">Key</span><span class="p">,</span> <span class="kt">Value</span><span class="o">&gt;</span> <span class="k">where</span> <span class="kt">Key</span> <span class="p">:</span> <span class="kt">CaseIterable</span><span class="p">,</span> <span class="kt">Key</span> <span class="p">:</span> <span class="kt">Hashable</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
              </ul>
            </div>
          </section>
        </section>
        <section id="footer">
          <p>&copy; 2019 <a class="link" href="" target="_blank" rel="external"></a>. All rights reserved. (Last updated: 2019-10-01)</p>
          <p>Generated by <a class="link" href="https://github.com/realm/jazzy" target="_blank" rel="external">jazzy ♪♫ v0.11.2</a>, a <a class="link" href="https://realm.io" target="_blank" rel="external">Realm</a> project.</p>
        </section>
      </article>
    </div>
  </body>
</div>
</html>
